

#define ERR  -1 
#define SUCC -2 

typedef char *ACTION ;   /* The command issued from this state */

typedef struct {ACTION action; int arcs; char **inputs; int *next ;} STATE ;

#define NUM_STATES 3 

/* State 0 arcs */

ACTION action_0    = "" ;
int      arcs_0    = 2 ;
char  *inputs_0 [] = {"login: ",  ""} ;
int      next_0 [] = {      1, ERR} ;

/* State 1 arcs */

ACTION action_1    = "dbc\n" ;
int      arcs_1    = 2 ;
char  *inputs_1 [] = {"bash$ ",  ""} ;
int      next_1 [] = {      2, ERR} ;

/* State 2 arcs */

ACTION action_2    = "logout\n" ;
int      arcs_2    = 1 ;
char  *inputs_2 [] = {  ""} ;
int      next_2 [] = {SUCC} ;

STATE machine [NUM_STATES] ;

void init_machine ()
{
  machine [0].action = action_0 ;
  machine [0].arcs   =   arcs_0 ;
  machine [0].inputs = inputs_0 ;
  machine [0].next   =   next_0 ;

  machine [1].action = action_1 ;
  machine [1].arcs   =   arcs_1 ;
  machine [1].inputs = inputs_1 ;
  machine [1].next   =   next_1 ;

  machine [2].action = action_2 ;
  machine [2].arcs   =   arcs_2 ;
  machine [2].inputs = inputs_2 ;
  machine [2].next   =   next_2 ;
}

void run_machine (f, t)
int f, t ;
{
  int state = 0;

  while ((state != SUCC) && (state != ERR))
  {
    STATE *curr_state = machine + state ;
    int arc ;

    arc = transaction (f, t, curr_state->action, curr_state->arcs,
			     curr_state->inputs) ;
    state = curr_state->next [arc] ;
  }
}

char *args[] = {"rtty", "cougar", (char *) 0} ;
/*
char *args[] = {"rtty", (char *) 0} ;
*/

void main ()
{
  int f, t ;  /* Stream descriptors */

  init_machine     () ;
  open_connection  (&f, &t, "rtty", args) ;
  run_machine      (f, t) ;
  close_connection (f, t) ;
}
